﻿using DistributedGA.Core.Domain;
using DistributedGA.Core.Interface;
using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Text;
using System.Threading.Tasks;

namespace DistributedGA.Core.Implementation
{
    public class WcfMessageSender : IMessageSender
    {
        private PeerInfo myself;

        public void Init(PeerInfo source)
        {
            myself = source;
        }

        public void SendPopulation(PeerInfo destination, SolutionInfo[] population)
        {
            var client = CreateServerClient(destination.IpAddress, destination.Port);
            client.SendPopulation(myself, population); //maybe timout exception...
        }

        private IMessageContract CreateServerClient(string ip, int port)
        {
            var serviceUrl = "DistributedGA.svc";
            var baseUri = new Uri(string.Concat("http://", ip, ":", port, "/DistributedGA"));
            var serviceUri = new Uri(baseUri, serviceUrl);

            var binding = new BasicHttpBinding();
            var endpoint = new EndpointAddress(serviceUri);
            var myChannelFactory = new ChannelFactory<IMessageContract>(binding, endpoint);

            IMessageContract client = null;
            client = myChannelFactory.CreateChannel();
            return client;
        }

    }
}
